-- FUNCTIONS DEFINITIONS

function loadpath(pathfilename)

--[[

Four formats allowed

   a      b       c       d

XXX[]XXXXX[]XXXXXX

XXX[]XXXXX[]XXXXXX[]$XXXX

XXX[]XXXXX[]XXXXXX[]XXXX XXXX XXXXX

XXX[]XXXXX[]XXXXXX[]$XXXX[]XXXX XXXX XXXXX
   a      b       c      d

--]]


	local lonstr,latstr, msgstr, inxa, inxb, inxc, inxd
	local myfile = io.open(pathfilename,"r")	
	local readline = myfile:read()
	local rdflinx = 1
	
	--external variables related to this function: trackpath[][], trackmsg[],tracksgn[]

	
	while (readline ~= nil) and (readline ~= ' ') do

	--term.out(readline)	
		
		inxa = string.find(readline, ' ',1 )
		inxb = string.find(readline, ' ',inxa + 1 ) 
		lonstr = string.sub(readline,inxa + 1, inxb - 1)
		inxc = string.find(readline,' ', inxb + 1)
		if inxc == nil then 
			 	latstr = string.sub(readline,inxb + 1)
			trackmsg[rdflinx] = nil
			tracksgn[rdflinx] = nil
		else
			latstr = string.sub(readline,inxb + 1,inxc - 1)
			msgstr = string.sub(readline,inxc + 1)
			if string.sub( msgstr,1,1) ~= '$' then
				trackmsg[rdflinx] = msgstr
				tracksgn[rdflinx] = nil
			else
				inxd = string.find(readline,' ', inxc + 1)
				if inxd == nil then
					trackmsg[rdflinx] = nil
					tracksgn[rdflinx] =  msgstr 
				else
					tracksgn[rdflinx] = string.sub(readline,inxc + 1,inxd-1)
					trackmsg[rdflinx] = string.sub(readline,inxd + 1)
				end
			end
			
		end	
			
			
		
		trackpath[rdflinx] = {}	
		trackpath[rdflinx][1] = math.rad(lonstr)
		trackpath[rdflinx][2] = math.rad(latstr)
		rdflinx = rdflinx + 1
	
		readline = myfile:read()
	

	end
	
	myfile:close()
	--term.out('load path ended')
	return rdflinx - 1
end



function coursebetweentwopoints( original_point, terminal_point )


	local dist_org2trm = oapi.orthodome (original_point, terminal_point)
	
	local tcrs_org2trm = math.acos((math.sin(terminal_point.lat) - math.sin(original_point.lat) *  math.cos(dist_org2trm))/(math.sin(dist_org2trm)*math.cos(original_point.lat)))	
	
	if math.sin(terminal_point.lng - original_point.lng) < 0 then
		tcrs_org2trm = 2 * PI - tcrs_org2trm
	end
	
	return tcrs_org2trm

end


function WhereamI(vtrain)
	--global refered pathlimit
	local dist2pnt,kpt_dist2pnt_1,kpt_dist2pnt_2, nrstinx_1, nrstinx_2
	local checkpoint = {}
	local PthTo
	
	local thistrainhdl = vtrain:get_handle()
	local thistrainpos = oapi.get_equpos(thistrainhdl)

	local pthinx = 1
	while pthinx <= pathlimit do
		checkpoint.lng = trackpath[pthinx][1]
		checkpoint.lat = trackpath[pthinx][2]
		dist2pnt= oapi.orthodome(thistrainpos,checkpoint)
		if pthinx ~= 1 then
			--this one neares the object
			if dist2pnt < kpt_dist2pnt_1 then
				kpt_dist2pnt_2 = kpt_dist2pnt_1
				kpt_dist2pnt_1 = dist2pnt
				nrstinx_2 = nrstinx_1
				nrstinx_1 = pthinx
				PthTo = pthinx	 
			end
			--this one gets farther than the last but is still nearer than the previous :PROX DECTECTED IN THIS SECTION
			if (dist2pnt > kpt_dist2pnt_1) and (dist2pnt < kpt_dist2pnt_2) then
				kpt_dist2pnt_2 = dist2pnt
				nrstinx_2 = pthinx
				PthTo = pthinx
				--term.out('break in the imanent leaving')
				break
			end 		 
			--this one gets farther than the last and is farther than the previous one :PROX DETECTED IN LAST SECTION
			if (dist2pnt > kpt_dist2pnt_1) and (dist2pnt > kpt_dist2pnt_2) then
				--term.out('break in the transcendent leaving')
				break
			end
			
		else --init trackpos 1
				kpt_dist2pnt_1 = dist2pnt
				kpt_dist2pnt_2 = 1e23
				nrstinx_1 = 1
				nrstinx_2 = 0
		end
		
		pthinx = pthinx + 1
	end
	--term.out('You are between points '..nrstinx_1..' and '..nrstinx_2)
	
	return PthTo
end	
	
	
	
function createrailthrust(vtrain)

	--thrust names denotes position of bocals, not vectors

	propreshdl = mtrain:create_propellantresource(100,100,1)


	local thspec={}
	thspec.pos={}
	thspec.dir = {}

	thspec.pos.x = 0
	thspec.pos.y = 0
	thspec.pos.z = -10
	thspec.dir.x = 1
	thspec.dir.y = 0
	thspec.dir.z = 0
	thspec.maxth0 = 10000
	thspec.hprop =propreshdl
	thspec.isp0= 1e5
	thspec.ispr = 0
	
	local threle = vtrain:create_thruster(thspec)

	thspec.pos.x = 0
	thspec.pos.y = 0
	thspec.pos.z = -10
	thspec.dir.x = -1
	thspec.dir.y = 0
	thspec.dir.z = 0
	thspec.maxth0 = 10000
	thspec.hprop =propreshdl
	thspec.isp0= 1e5
	thspec.ispr = 0

	local threri = vtrain:create_thruster(thspec)

	thspec.pos.x = 0
	thspec.pos.y = 0
	thspec.pos.z = 10
	thspec.dir.x = 1
	thspec.dir.y = 0
	thspec.dir.z = 0
	thspec.maxth0 = 10000
	thspec.hprop =propreshdl
	thspec.isp0= 1e5
	thspec.ispr = 0

	local thfrle = vtrain:create_thruster(thspec)

	thspec.pos.x = 0
	thspec.pos.y = 0
	thspec.pos.z = 10
	thspec.dir.x = -1
	thspec.dir.y = 0
	thspec.dir.z = 0
	thspec.maxth0 = 10000
	thspec.hprop =propreshdl
	thspec.isp0= 1e5
	thspec.ispr = 0

	local thfrri = vtrain:create_thruster(thspec)

	vtrain:create_thrustergroup( {thfrri,thlrele} ,THGROUP.ATT_YAWLEFT)
	vtrain:create_thrustergroup( {thfrle,thlreri} ,THGROUP.ATT_YAWRIGHT)

end

function CabSignalInit()

	Rlight = oapi.create_annotation()
	Ylight = oapi.create_annotation()
	Glight = oapi.create_annotation()
	--Frame = oapi.create_annotation()
	
	--Frame:set_pos(.887,.132,1,1)
	Rlight:set_pos( .9,0,1,1)
	Ylight:set_pos( .9,.03,1,1)
	Glight:set_pos( .9,.06,1,1)
	--Frame:set_size(6)
	Rlight:set_size(8)
	Ylight:set_size(8)
	Glight:set_size(8)
	--Frame:set_colour({r=0,g=0,b=0})
	Rlight:set_colour({r=0,g=0,b=0})
	Ylight:set_colour({r=0,g=0,b=0})
	Glight:set_colour({r=0,g=0,b=0})
	
	--Frame:set_text('')
	Rlight:set_text('')
	Ylight:set_text('')
	Glight:set_text('')

end

function TurnCabSignalON()

	--Frame:set_text('0')
	Rlight:set_text('.')
	Ylight:set_text('.')
	Glight:set_text('.')
	
end


function TurnCabSignalOFF()

	--Frame:set_text('')
	Rlight:set_text('')
	Ylight:set_text('')
	Glight:set_text('')

end


function SetCabSignalSTOP()

	Rlight:set_colour({r=1,g=0,b=0})
	Ylight:set_colour({r=.25,g=.25,b=0})
	Glight:set_colour({r=0,g=.25,b=0})
	return '$STOP'
end


function SetCabSignalAPPROACH()

	Rlight:set_colour({r=.25,g=0,b=0})
	Ylight:set_colour({r=1,g=1,b=0})
	Glight:set_colour({r=0,g=.25,b=0})
	return '$APPROACH'
end

function SetCabSignalCLEAR()

	Rlight:set_colour({r=.25,g=0,b=0})
	Ylight:set_colour({r=.25,g=.25,b=0})
	Glight:set_colour({r=0,g=1,b=0})
	return '$CLEAR'
end

function trackposchkUpd(trix)
	--Globals refered tracklimit
	--Globals Affected: trackpos[]

	local trkup = false
	local terminal_base = {}
	
	local trainif = vessel.get_interface(trix)
	local trainhdl = trainif:get_handle()

	local my_train_pos = oapi.get_equpos(trainhdl)
	terminal_base.lng = trackpath[trackpos[trix]][1]
	terminal_base.lat = trackpath[trackpos[trix]][2]

	local distoterm = oapi.orthodome (my_train_pos, terminal_base)
	

	if distoterm <1e-5 and trackpos[trix] < pathlimit then
			trkup = true
			trackpos[trix] = trackpos[trix] + 1 --which ensures that next time the distance will be one block long
			--term.out('detected proximity: trackpos incremented')
	end

	return trkup

end

function WptTrgSgnMsg(inxtrn)
	--Globals Affected:cbnmsgend,tgttrainif, tgttrainhdl,sgnmeet,sgnobj,cbnmsgend,sgntimeend
	-- The above are non-indexed globals because they are related only to the current in focus train situation
	--Globals Refered:currtime,tracksgn[],trackpos[], tracksgn[]
	local msgflg,sgnflg,sgnmode,sgnobj, CabsignalStatus

	if trackmsg[trackpos[inxtrn]-1]~= nil then 
   		cabmsg:set_text(trackmsg[trackpos[inxtrn]-1])
   		cbnmsgend = currtime +10
   		msgflg = true
	else
		cabmsg:set_text('')
		cbnmsgend = nil
		msgflg = false
	end
 
   		
	if tracksgn[trackpos[inxtrn]-1]~= nil then
		sgnflg = true
   		sgnobjinx = string.find(tracksgn[trackpos[inxtrn]-1],'*')
   		if sgnobjinx ~= nil then
   		 	sgnmode = string.sub(tracksgn[trackpos[inxtrn]-1],1, sgnobjinx - 1)
   		 	sgnobj = string.sub(tracksgn[trackpos[inxtrn]-1], sgnobjinx + 1)
   		 	if string.sub(sgnobj, 1, 1) == '0' then --time set
   			 	sgntimeend = currtime + sgnobj
   			end
   		else
   			sgnmode = string.sub(tracksgn[trackpos[inxtrn]-1],1)
   	 		sgntimeend = nil
   		end
    
    	if sgnmode == '$STOP' then
    		CabsignalStatus = SetCabSignalSTOP()
    	end
    	if sgnmode == '$APPROACH' then
    		CabsignalStatus = SetCabSignalAPPROACH()
   		end
    	if sgnmode == '$CLEAR' then
    	--term.out('Triggered with signmode')
    		CabsignalStatus = SetCabSignalCLEAR()
    	end

	else
		--term.out('Triggered by default')
		CabsignalStatus = SetCabSignalCLEAR()
		sgnflg = false
	end

   	return sgnflg or msgflg
   		
end

function TrackTarget(fcstrinx,tgttrinx)
local CabsignalStatus
	if mtrinx ~= tgttrinx then
		local tgttrif =  vessel.get_interface(tgttrinx)
 		local tgttrhdl = tgttrif:get_handle()
 		local tgt_train_pos = oapi.get_equpos(tgttrhdl)
		
		local fcstrif =  vessel.get_interface(fcstrinx)
 		local fcstrhdl = fcstrif:get_handle()
		local fcs_train_pos = oapi.get_equpos(fcstrhdl)
		
		local distfcstgt = oapi.orthodome (fcs_train_pos, tgt_train_pos)
   		
		if distfcstgt < SGNMEET then
			CabsignalStatus = SetCabSignalSTOP()
			ctccmdflg = false
		end
		
		if distfcstgt > SGNMEET and distotrain < SGNMEET * 2 and ctccmdflg == false then 
			CabsignalStatus = SetCabSignalAPPROACH()
		end
		
		if distfcstgt > SGNMEET * 2 and ctccmdflg == false then
			--term.out('Tracking too far')
			CabsignalStatus = SetCabSignalCLEAR()
		end
	else
		CabsignalStatus = nil	
	end
	
	return CabsignalStatus	
		
end

function RailAP(trix)
	


local terminal_base = {}
local original_base = {}
local my_train_pos = {}
   
--		 		Railing Action Autopilot: Get feedback signals   
	
	local trif =  vessel.get_interface(trix)
	local trhdl = vessel.get_handle(trix)
	my_train_pos = oapi.get_equpos(trhdl)
	terminal_base.lng = trackpath[trackpos[trix]][1]
	terminal_base.lat = trackpath[trackpos[trix]][2]
	original_base.lng = trackpath[trackpos[trix]-1][1]
	original_base.lat = trackpath[trackpos[trix]-1][2]

	local railcourse = coursebetweentwopoints(original_base, terminal_base)	 

	local traincourse = coursebetweentwopoints(my_train_pos, terminal_base)	 

	

--		 		Railing Action Autopilot: course error calculation	
	local deltacourse = traincourse - railcourse

	if deltacourse < -PI then deltacourse = 2 * PI + deltacourse end
	if deltacourse > PI then deltacourse = deltacourse - 2 * PI	end

--		 		Railing Action Autopilot :correction course calculation
	local coursetofollow = railcourse + deltacourse*3  
	if deltacourse > .17453 then coursetofollow = railcourse + PI/2 end
	if deltacourse < -.17453 then coursetofollow = railcourse - PI/2 end 
	--term.out('got course to follow.... will act')
	
	
--		 		Railing Action Autopilot: heading error calculation
	local trainhead = oapi.get_heading(trhdl)
	local deltahead = trainhead - coursetofollow

--		 		Railing Action Autopilot:Action Calculation
	--local action = math.pow(deltahead,2) *1e6
	local action = math.abs(deltahead/math.pow(oapi.get_sysstep(),2))*1e0
	
	if action >=1 then action =1 end

--				Railing Action Autopilot Safeguard: No action when stopped

	if 	trif:get_airspeed() < 1 then action = 0 end 

--		 		Railing Action Autopilot: Action on thrusters
	if deltahead < 0 then
	
		mtrain:set_thrustergrouplevel(THGROUP.ATT_YAWLEFT,0)
		mtrain:set_thrustergrouplevel(THGROUP.ATT_YAWRIGHT,action)
		--indicator = '>'
	else
		mtrain:set_thrustergrouplevel(THGROUP.ATT_YAWRIGHT,0)
		mtrain:set_thrustergrouplevel(THGROUP.ATT_YAWLEFT,action)
		--indicator = '<'
		action = -action
	end
	--term.out('acted')
	
	return action

end 

function VsslInxfrmNme(vnme)
	local vidx
	local manyvessels = vessel.get_count()
	if manyvessels ~= 0 then 
		vidx = 0
		local vk = vessel.get_interface(vidx)
		while vnme ~=  vk:get_name() do
			vidx = vidx + 1
			if vidx == manyvessels then
				 vidx = nil
				 break
			 end
			vk = vessel.get_interface(vidx)
		end
		
	end
	return vidx
end

function RMain(DispatcherFilename)
	SGNMEET = 2500/1738000


	--VARS INIT

	--term.out('begin init' )

	trackpath = {}
	trackpos={}

	trackmsg = {}
	tracksgn = {}

	term.out('will load dispatcher')
	pathlimit = loadpath(DispatcherFilename)
	term.out('dispatcher file loaded')



--ASSIGNED VESSEL INITIAL ATTRIBUTIONS
Usrtrnme = 'PAX'

thistrainx = VsslInxfrmNme(Usrtrnme)
mtrain = vessel.get_interface(thistrainx)
mtrainhdl = mtrain:get_handle()


createrailthrust(mtrain)


trackpos[thistrainx] = WhereamI(mtrain)



--CABSIGNAL SYSTEM INIT
CabsignalStatus = CabSignalInit()
CabsignalStatus = SetCabSignalCLEAR()
CabsignalStatus = TurnCabSignalON()
cabmsg = oapi.create_annotation()

--term.out('end inits would begin looping')

--k=0 --program counter for limited loop 
while true do

--***************************************************
--				World Inquires

	currtime = oapi.get_simtime()
	mytrain = VsslInxfrmNme(Usrtrnme)
	
--***************************************************


--*******************************************************
--		Waypoint Arrival Check and Next Waypoint Updating

	poschanged = trackposchkUpd(mytrain)
		
--*************************************************
--		 Cabin Message and Signal System 
	
	--Part1 Waypoint Triggered Activation/Deactivation
    if poschanged == true then -- poschanged is updated by trackposchkUpd()
    	thereissgnormsg = WptTrgSgnMsg(mytrain)	
   	end
	
		--Part2 Time Triggered Activation/Deactivation
   	
   	if cbnmsgend ~= nil then
   		if  currtime > cbnmsgend then 
   			cabmsg:set_text('')
   			cbnmsgend = nil
   		end
   	end
	
	
	if sgntimeend ~= nil then
   		if  currtime > sgntimeend then 
   			term.out('Cleared by time in main')
   			CabsgnSts = SetCabSignalCLEAR()
   			sgntimeend = nil
   		end
   	end
   	
	 	--Part3 Proximity Triggered Activation/Deactivation
   	if SGNMEET ~= nil then		
		targetstatus = TrackTarget(mytrain,tgttrain)
	end		
	
--**********************************************************************
--				 		RAILING ACTION AUTOPILOT 


--[[
Acting Signal: Difference between Train Heading and heading needed for correction to Specified Train Course
Controlled Output: Train Course (should be directed to  Rail Course)
Handled Variable: Yaw Power and Orientation (user created thrusters)
Reference Input: Rail Course or Specified Train Course( from original to terminal )
Primary Feedback signal: Train Course ( to terminal )
Secondary Feedback Signal: Train Heading
--]]
	
	act = RailAP(mytrain)
	
	
--**********************************************************************	
	
	
	
	--k = k + 1 --loop counter increment
	

	
	proc.skip()

end

end